## dipy 1.6.0

=== Makefile ===
# Simple makefile to quickly access handy build commands for Cython extension
# code generation.  Note that the actual code to produce the extension lives in
# the setup.py file, this Makefile is just meant as a command
# convenience/reminder while doing development.

PYTHON ?= python
PKGDIR=dipy
DOCSRC_DIR=doc
DOCDIR=${PKGDIR}/${DOCSRC_DIR}
TESTDIR=${PKGDIR}/tests

help:
	@echo "Numpy/Cython tasks.  Available tasks:"
	@echo "ext  -> build the Cython extension module."
	@echo "cython-html -> create annotated HTML from the .pyx sources"
	@echo "test -> run a simple test demo."
	@echo "all  -> Call ext, html and finally test."

all: ext cython-html test

ext: recspeed.so propspeed.so vox2track.so \
    distances.so streamlinespeed.so denspeed.so \
    vec_val_sum.so quick_squash.so vector_fields.so \
    crosscorr.so sumsqdiff.so expectmax.so bundlemin.so \
    cythonutils.so featurespeed.so metricspeed.so \
    clusteringspeed.so clustering_algorithms.so \
    mrf.so

test: ext
	pytest -s --verbose --doctest-modules .

cython-html:  ${PKGDIR}/reconst/recspeed.html ${PKGDIR}/tracking/propspeed.html ${PKGDIR}/tracking/vox2track.html ${PKGDIR}/tracking/distances.html ${PKGDIR}/tracking/streamlinespeed.html ${PKGDIR}/segment/cythonutils.html ${PKGDIR}/segment/featurespeed.html ${PKGDIR}/segment/metricspeed.html ${PKGDIR}/segment/clusteringspeed.html ${PKGDIR}/segment/clustering_algorithms.html

recspeed.so: ${PKGDIR}/reconst/recspeed.pyx
cythonutils.so: ${PKGDIR}/segment/cythonutils.pyx
featurespeed.so: ${PKGDIR}/segment/featurespeed.pyx
metricspeed.so: ${PKGDIR}/segment/metricspeed.pyx
mrf.so: ${PKGDIR}/segment/mrf.pyx
clusteringspeed.so: ${PKGDIR}/segment/clusteringspeed.pyx
clustering_algorithms.so: ${PKGDIR}/segment/clustering_algorithms.pyx
propspeed.so: ${PKGDIR}/tracking/propspeed.pyx
vox2track.so: ${PKGDIR}/tracking/vox2track.pyx
distances.so: ${PKGDIR}/tracking/distances.pyx
streamlinespeed.so: ${PKGDIR}/tracking/streamlinespeed.pyx
denspeed.so: ${PKGDIR}/denoise/denspeed.pyx
vec_val_sum.so: ${PKGDIR}/reconst/vec_val_sum.pyx
quick_squash.so: ${PKGDIR}/reconst/quick_squash.pyx
vector_fields.so: ${PKGDIR}/align/vector_fields.pyx
crosscorr.so: ${PKGDIR}/align/crosscorr.pyx
sumsqdiff.so: ${PKGDIR}/align/sumsqdiff.pyx
expectmax.so: ${PKGDIR}/align/expectmax.pyx
bundlemin.so: ${PKGDIR}/align/bundlemin.pyx

	$(PYTHON) setup.py build_ext --inplace

# Phony targets for cleanup and similar uses

.PHONY: clean

clean:
	- find ${PKGDIR} -name "*.so" -print0 | xargs -0 rm
	- find ${PKGDIR} -name "*.pyd" -print0 | xargs -0 rm
	- find ${PKGDIR} -name "*.c" -print0 | xargs -0 rm
	- find ${PKGDIR} -name "*.html" -print0 | xargs -0 rm
	rm -rf build
	rm -rf docs/_build
	rm -rf docs/dist
	rm -rf dipy/dipy.egg-info

distclean: clean
	rm -rf dist

# Suffix rules
%.c : %.pyx
	cython $<

%.html : %.pyx
	cython -a $<

# Check for files not installed
check-files:
	$(PYTHON) -c 'from nisext.testers import check_files; check_files("dipy")'

# Print out info for possible install methods
check-version-info:
	$(PYTHON) -c 'from nisext.testers import info_from_here; info_from_here("dipy")'

# Run tests from installed code
installed-tests:
	$(PYTHON) -c 'from nisext.testers import tests_installed; tests_installed("dipy")'

# Run tests from installed code
sdist-tests:
	$(PYTHON) -c 'from nisext.testers import sdist_tests; sdist_tests("dipy")'

bdist-egg-tests:
	$(PYTHON) -c 'from nisext.testers import bdist_egg_tests; bdist_egg_tests("dipy")'

source-release: clean
	$(PYTHON) -m compileall .
	$(PYTHON) setup.py sdist --formats=gztar,zip

binary-release: clean
	$(PYTHON) setup_egg.py bdist_egg

build-stamp-source:
	$(PYTHON) -c 'import cythexts; cythexts.build_stamp_source()'

# Checks to see if local files pass formatting rules
format:
	python -m pycodestyle dipy

=== requirements.txt ===
# Check against .travis.yml file and dipy/info.py
cython>=0.29.24, !=0.29.29
numpy>=1.14.5
scipy>=1.1
nibabel>=3.0.0
h5py>=2.8.0
packaging>=19.0
tqdm>=4.30.0

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d _build/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  api       to make the auto-generated API files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean: api-clean examples-clean
	-rm -rf _build/*
	-rm *-stamp

api-clean:
	rm -rf reference/*.rst
	rm -rf reference_cmd/*.rst

api:
	@mkdir -p reference
	$(PYTHON) tools/build_modref_templates.py dipy reference
	@mkdir -p reference_cmd
	$(PYTHON) tools/docgen_cmd.py dipy reference_cmd
	@echo "Build API docs...done."

examples-clean:
	-cd examples_built && rm -rf *.py *.rst *.png fig

examples-clean-tgz: examples-clean examples-tgz
	../tools/pack_examples.py ../dist

examples-tgz: rstexamples
	../tools/pack_examples.py ../dist

gitwash-update:
	python ../tools/gitwash_dumper.py devel dipy --repo-name=dipy --github-user=dipy \
            --project-url=https://dipy.org \
            --project-ml-url=https://mail.python.org/mailman/listinfo/neuroimaging

html: api rstexamples html-after-examples
	# build full docs including examples

html-after-examples:
	# Standard html build after examples have been prepared
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) _build/html
	@echo
	@echo "Build finished. The HTML pages are in _build/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) _build/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in _build/dirhtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) _build/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) _build/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) _build/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in _build/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) _build/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in _build/qthelp, like this:"
	@echo "# qcollectiongenerator _build/qthelp/dipy.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile _build/qthelp/dipy.qhc"

latex: rstexamples latex-after-examples

latex-after-examples:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) _build/latex
	@echo
	@echo "Build finished; the LaTeX files are in _build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) _build/changes
	@echo
	@echo "The overview file is in _build/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) _build/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in _build/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) _build/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in _build/doctest/output.txt."

rstexamples: rstexamples-stamp
rstexamples-stamp:
	cd examples_built && ../../tools/make_examples.py
	touch $@

pdf: pdf-stamp
pdf-stamp: latex
	cd _build/latex && make all-pdf
	touch $@

upload: html
	./upload-gh-pages.sh _build/html/ dipy dipy

xvfb:
	export TEST_WITH_XVFB=true && make html

memory_profile:
	export TEST_WITH_MEMPROF=true && make html

=== debian/changelog ===
dipy (1.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version

 -- Andreas Tille <tille@debian.org>  Fri, 27 Jan 2023 19:35:20 +0100

dipy (1.5.0-7) unstable; urgency=medium

  * Team upload.
  * Do not measure wall-clock time (thanks for the patch to Rebecca N.
    Palmer)
    Closes: #1029533

 -- Andreas Tille <tille@debian.org>  Tue, 24 Jan 2023 20:12:50 +0100

dipy (1.5.0-6) unstable; urgency=medium

  * Team upload.
  * Add upstream patch to work with numpy 1.24

 -- Andreas Tille <tille@debian.org>  Mon, 09 Jan 2023 19:00:33 +0100

dipy (1.5.0-5) unstable; urgency=medium

  * d/control: recommend python3-vtk9 instead of vtk7.
  * d/t/control: bump to vtk9 in test dependencies too.
    The missing dependency on python3-vtk7 seems to have caused a red
    herring in numpy 1.24 transition. (Closes: #1027200)
  * d/copyright: bump copyright year.
  * d/control: declare compliance to standards version 4.6.2.
  * d/rules: make data file not executable.
  * d/*.lintian-overrides: fix mismatched override.

 -- Étienne Mollier <emollier@debian.org>  Sat, 07 Jan 2023 13:14:10 +0100

=== debian/control ===
Source: dipy
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
           Michael Hanke <mih@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: python
Testsuite: autopkgtest-pkg-python
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               libgomp1,
               cython3,
               python3-all-dev,
               python3-setuptools,
               python3-numpy,
               python3-scipy,
               python3-h5py <!nocheck>,
               python3-matplotlib <!nocheck>,
               python3-nibabel (>= 3.0.0) <!nocheck>,
               python3-pil.imagetk <!nocheck>,
               python3-pytest <!nocheck>,
               python3-pandas <!nocheck>,
               python3-tables <!nocheck>,
               python3-tk <!nocheck>,
               python3-sklearn <!nocheck>,
               python3-tqdm <!nocheck>,
               xvfb <!nocheck>,
               xauth <!nocheck>
Build-Depends-Indep: python3-sphinx,
                     python3-numpydoc,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/dipy
Vcs-Git: https://salsa.debian.org/med-team/dipy.git
Homepage: https://dipy.org
Rules-Requires-Root: no

Package: python3-dipy
Architecture: all
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
         python3-numpy,
         python3-scipy,
         python3-h5py,
         python3-pandas,
         python3-dipy-lib (>= ${source:Version}),
         python3-tqdm,
         python3-packaging
Recommends: python3-matplotlib,
            python3-vtk9,
            python3-nibabel,
            python3-tables,
            python3-sklearn
Suggests: python-dipy-doc
Provides: ${python3:Provides}
Description: Python library for the analysis of diffusion MRI datasets
 DIPY is a software project for computational neuroanatomy. It focuses
 on diffusion magnetic resonance imaging (dMRI) analysis and
 tractography but also contains implementations of other computational
 imaging methods such as denoising and registration that are
 applicable to the greater medical imaging and image processing
 communities. Additionally, DIPY is an international project which
 brings together scientists across labs and countries to share their
 state-of-the-art code and expertise in the same codebase,
 accelerating scientific research in medical imaging.
 .
 Here are some of the highlights:
  - Reconstruction algorithms: CSD, DSI, GQI, DTI, DKI, QBI, SHORE
    and MAPMRI
  - Fiber tracking algorithms: deterministic and probabilistic
  - Native linear and nonlinear registration of images
  - Fast operations on streamlines (selection, resampling, registration)
  - Tractography segmentation and clustering
  - Many image operations, e.g., reslicing or denoising with NLMEANS
  - Estimation of distances/correspondences between streamlines and
    connectivity matrices
  - Interactive visualization of streamlines in the space of images
 .
 This package contains the Python 3 version.
XB-Python3-Version: ${python3:Versions}

Package: python3-dipy-lib
Architecture: any
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Provides: ${python3:Provides}
Multi-Arch: same
Description: Python library for the analysis of diffusion MRI datasets -- Python3 extensions
 DIPY is a library for the analysis of diffusion magnetic resonance
 imaging data.
 .
 This package provides architecture-dependent builds of the extensions
 for Python3.

Package: python-dipy-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery,
         libjs-mathjax
Suggests: python3-dipy
Multi-Arch: foreign
Description: Python library for the analysis of diffusion MRI datasets -- documentation
 DIPY is a library for the analysis of diffusion magnetic resonance
 imaging data.
 .
 This package provides the documentation in HTML format.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export PYBUILD_NAME=dipy

PACKAGE3_NAME = python3-$(PYBUILD_NAME)

PACKAGE3_ROOT_DIR = $(CURDIR)/debian/${PACKAGE3_NAME}
INSTALL_PATH = $(CURDIR)/debian/tmp

ifeq (,$(findstring get-orig-source, $(MAKECMDGOALS)))
export  http_proxy=http://127.0.0.1:9/
endif

# default Python
PY3VERS = $(shell py3versions -vr)
PY3VER = $(shell py3versions -vd)

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

MIN_CYTHONVER = 0.25.1

BUILD_DATE := "$(date --utc --date="@${SOURCE_DATE_EPOCH:-$(date +%s)}" +%B %d, %Y)"
SPHINXOPTS := -D today=\"$(BUILD_DATE)\"

ifneq (,$(findstring $(DEB_BUILD_ARCH),s390x))
REMOVE_FILES := dipy/align/tests/test_streamlinear.py dipy/align/tests/test_streamline.py dipy/tracking/tests/test_distances.py dipy/viz/tests/test_fury.py dipy/workflows/tests/test_align.py dipy/workflows/tests/test_segment.py dipy/align/tests/test_whole_brain_slr.py dipy/data/tests/test_data.py
endif

%:
	dh $@ --buildsystem=pybuild --with python3

execute_before_dh_auto_configure:
	rm -f $(REMOVE_FILES)

override_dh_auto_clean:
	dh_auto_clean || true
	rm -rf .pybuild __pycache__

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	: # Do not test just after build, lets install and then test
endif

override_dh_auto_build:
	chmod 0644 doc/examples/*.py
	dh_auto_build
	echo "backend : Agg" >| build/matplotlibrc
	find -name func_coef.nii.gz -print -exec chmod 0644 '{}' ';'

override_dh_auto_install:
	dh_auto_install
	: # Prune duplicate LICENSE file
	find debian/ -name LICENSE -delete
	: # Only now lets build docs
ifeq (python-dipy-doc_,$(filter python-dipy-doc,$(shell dh_listpackages))_$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	export PYTHONPATH=$(shell pybuild --print build_dir --interpreter python3) \
		   MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build; \
	cd doc; $(MAKE) html-after-examples SPHINXOPTS="$(SPHINXOPTS)"
	-rm doc/_build/html/_static/jquery.js
	-rm -r doc/_build/html/_sources
	: # objects inventory is of no use for the package
	-rm doc/_build/html/objects.inv
	# references to cloudflare and github are privacy breaches
	sed 's@https://cdnjs\.cloudflare\.com/ajax/libs/mathjax/[^/]\+/@file:///usr/share/javascript/mathjax/unpacked/@' \
		-i doc/_build/html/*.html \
		   doc/_build/html/interfaces/*.html \
		   doc/_build/html/theory/*.html
	# FIXME: references to github are for images part of dipy_data, which
	# is not available in debian; these may need packaging to solve the
	# privacy breach here.
endif
	# Run tests later on
	# cd build to prevent use of local/not-built source tree
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -ex \
	; export http_proxy=http://127.0.0.1:9/ \
	; export https_proxy=https://127.0.0.1:9/ \
	; for PYTHON in $(PY3VERS) \
	; do	PYPKG="$(PACKAGE3_ROOT_DIR)/usr/lib/python$$PYTHON/dist-packages" \
	;	export PYTHONPATH="$$PYPKG" \
	;	echo "I: Running Dipy unittests using $$PYTHON" \
	;	cd "$$PYPKG" \
	;	PATH=$(PACKAGE3_ROOT_DIR)/usr/bin:$$PATH \
			HOME=/tmp \
			MPLCONFIGDIR=/tmp/ xvfb-run -a -s "-screen 0 1280x1024x24 -noreset" \
			python$$PYTHON -m pytest dipy \
	;	rm .pytest_cache -rf \
	; done
endif
	find debian/$(PACKAGE3_NAME)/usr/lib/python3* \( -name affine.txt -o -name "*.trk" \) -delete

## "Instantiate" both rules so dh sees them
override_dh_python3:
	set -e \
	; test -d debian/$(PACKAGE3_NAME)/usr/lib || exit 0 \
	; for lib in $$(find debian/$(PACKAGE3_NAME)/usr/lib -name "*.so") \
	; do	sdir=$$(dirname $$lib) \
	;	tdir=debian/$(PACKAGE3_NAME)-lib/$${sdir#*$(PACKAGE3_NAME)/} \
	;	mkdir -p "$${tdir}" \
	;	mv -v "$${lib}" "$${tdir}" \
	; done
	dh_numpy3 -p$(PACKAGE3_NAME)-lib
	dh_python3

## immediately useable documentation
## and exemplar data (they are small excerpts anyway)
override_dh_compress:
	dh_compress -X.py -X.html -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -X.par -X.bin -Xobjects.inv

override_dh_clean:
	: # I: Custom cleaning
	rm -rf build doc-stamp
	$(MAKE) -C doc clean
	dh_clean

override_dh_dwz:
	dh_dwz || true

inject-doc-examples:
	mkdir -p doc-examples
	tar -C doc-examples --strip-components 1 \
	 -xzvf ../tarballs/$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig-doc-examples.tar.gz

=== debian/tests/control ===
Test-Command: cp -a /usr/lib/python3/dist-packages/dipy $AUTOPKGTEST_TMP && cp -a dipy/data $AUTOPKGTEST_TMP/dipy && cd $AUTOPKGTEST_TMP && HOME=/tmp MPLCONFIGDIR=/tmp/ xvfb-run --auto-servernum --server-num=20 -s "-screen 0 1024x768x24 -ac +extension GLX +render -noreset" python3 -m pytest dipy
Depends: @, python3-all,
            python3-pytest,
            xvfb, xauth,
            python3-matplotlib,
            python3-vtk9,
            python3-nibabel,
            python3-tables,
            python3-sklearn
Restrictions: allow-stderr, needs-internet

# Try running examples as autopkgtest to address bug #994575 - but
# several of them seem to require user interaction or additional
# modules - thus the test needs to be deactivated and is just some
# proof of concept currently

#Test-Command: xvfb-run --auto-servernum --server-num=20 -s "-screen 0 1024x768x24 -ac +extension GLX +render -noreset" sh debian/tests/run-unit-test
#Depends: @, python3-all,
#            python3-pytest,
#            xvfb, xauth,
#            python3-matplotlib,
#            python3-vtk9,
#            python3-nibabel,
#            python3-tables,
#            python3-sklearn
#Restrictions: allow-stderr, needs-internet

## dipy 1.7.0

=== requirements.txt ===


=== doc/Makefile ===
--- 
+++ 
@@ -56,12 +56,24 @@
             --project-url=https://dipy.org \
             --project-ml-url=https://mail.python.org/mailman/listinfo/neuroimaging
 
-html: api rstexamples html-after-examples
+html-legacy: api rstexamples html-after-examples-legacy
 	# build full docs including examples
 
-html-after-examples:
+html-after-examples-legacy:
 	# Standard html build after examples have been prepared
 	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) _build/html
+	@echo
+	@echo "Build finished. The HTML pages are in _build/html."
+
+html: api
+	#  Standard html build after examples have been prepared
+	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) _build/html
+	@echo
+	@echo "Build finished. The HTML pages are in _build/html."
+
+html-no-examples: api
+	# Standard html build after examples have been prepared
+	$(SPHINXBUILD) -D plot_gallery=0 -b html $(ALLSPHINXOPTS) _build/html
 	@echo
 	@echo "Build finished. The HTML pages are in _build/html."

=== debian/changelog ===
dipy (1.7.0-3) unstable; urgency=medium

  * Team upload.

  [ Nathan Pratta Teodosio ]
  * skip-streamwarp-test-in-big-endian.patch: skip streamwarp tests in
    big endian architectures (Closes: #1050037).

  [ Michael R. Crusoe ]
  * d/patches: update forwarding status
  * d/control, d/clean, d/rules: cleanup better after a build. Closes: #1044608
  * d/patches/python3: rewrite some hashbang headers that dh_python missed

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 28 Sep 2023 10:48:22 +0200

dipy (1.7.0-2) unstable; urgency=medium

  * skip-stringent-test.patch: new: skip a failing test.
    The test_cross is too stringent and only succeeds on a couple of
    architectures like amdd64 and similar.  This fixes ftbfs on arm64,
    ppc64el, riscv64 and possibly others.  This is not sufficient to
    resolve the additional failures seen on big endian systems though.

 -- Étienne Mollier <emollier@debian.org>  Fri, 18 Aug 2023 15:45:57 +0200

dipy (1.7.0-1) unstable; urgency=medium

  * New upstream version 1.7.0
  * d/control: cleanup build dependency on ancient nibabel version.
  * d/rules: replace html-after-examples by html target.
    html-after-examples has been replaced by html-after-examples-legacy,
    which looks to be mostly the same as the new html target (which in
    turn also has an html-legacy target)
  * d/rules: fix shebangs as python is not python3.
  * d/rules: remove inc_static.nii.gz from python3 modules directory.
  * no-network.patch: added; skip sphinx gallery.
    The sphinx gallery only works when accessing Internet resources.
  * skip-tests-needing-internet.patch: update.
    There is one new test which requires being skipped due to requiring
    Internet access.
  * deb_no_sources_for_docs patch: refresh.
  * crossbuild.patch: refresh.
  * spelling-error-in-binary.patch: refresh; partially applied upstream.
  * fix-invalid-version.patch: new patch.
    This fixes failure to build the documentation due to a trailing dot
    landing somehow in the module version.

 -- Étienne Mollier <emollier@debian.org>  Tue, 18 Jul 2023 18:25:16 +0200

=== debian/control ===
--- 
+++ 
@@ -10,13 +10,14 @@
                dh-python,
                libgomp1,
                cython3,
+               python-is-python3,
                python3-all-dev,
                python3-setuptools,
                python3-numpy,
                python3-scipy,
                python3-h5py <!nocheck>,
                python3-matplotlib <!nocheck>,
-               python3-nibabel (>= 3.0.0) <!nocheck>,
+               python3-nibabel <!nocheck>,
                python3-pil.imagetk <!nocheck>,
                python3-pytest <!nocheck>,
                python3-pandas <!nocheck>,
@@ -27,7 +28,7 @@
                xvfb <!nocheck>,
                xauth <!nocheck>
 Build-Depends-Indep: python3-sphinx,
-                     python3-numpydoc,
+                     python3-numpydoc
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/dipy
 Vcs-Git: https://salsa.debian.org/med-team/dipy.git
@@ -81,11 +82,11 @@
 
 Package: python3-dipy-lib
 Architecture: any
+Multi-Arch: same
 Depends: ${python3:Depends},
          ${shlibs:Depends},
          ${misc:Depends}
 Provides: ${python3:Provides}
-Multi-Arch: same
 Description: Python library for the analysis of diffusion MRI datasets -- Python3 extensions
  DIPY is a library for the analysis of diffusion magnetic resonance
  imaging data.
@@ -95,12 +96,12 @@
 
 Package: python-dipy-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends},
          libjs-jquery,
          libjs-mathjax
 Suggests: python3-dipy
-Multi-Arch: foreign
 Description: Python library for the analysis of diffusion MRI datasets -- documentation
  DIPY is a library for the analysis of diffusion magnetic resonance
  imaging data.

=== debian/rules ===
--- 
+++ 
@@ -37,6 +37,7 @@
 override_dh_auto_clean:
 	dh_auto_clean || true
 	rm -rf .pybuild __pycache__
+	find dipy -name "*\.c" -delete
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
@@ -57,7 +58,7 @@
 ifeq (python-dipy-doc_,$(filter python-dipy-doc,$(shell dh_listpackages))_$(filter nodoc,$(DEB_BUILD_OPTIONS)))
 	export PYTHONPATH=$(shell pybuild --print build_dir --interpreter python3) \
 		   MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build; \
-	cd doc; $(MAKE) html-after-examples SPHINXOPTS="$(SPHINXOPTS)"
+	cd doc; $(MAKE) html SPHINXOPTS="$(SPHINXOPTS)"
 	-rm doc/_build/html/_static/jquery.js
 	-rm -r doc/_build/html/_sources
 	: # objects inventory is of no use for the package
@@ -89,7 +90,12 @@
 	;	rm .pytest_cache -rf \
 	; done
 endif
-	find debian/$(PACKAGE3_NAME)/usr/lib/python3* \( -name affine.txt -o -name "*.trk" \) -delete
+	# Cleanup files landing unnecessarily in the python3 modules directory.
+	find $(CURDIR)/debian/$(PACKAGE3_NAME)/usr/lib/python3* \( \
+		-name affine.txt \
+		-o -name "*.trk" \
+		-o -name inc_static.nii.gz \
+	\) -delete
 
 ## "Instantiate" both rules so dh sees them
 override_dh_python3:

## dipy 1.8.0

=== Makefile ===
--- 
+++ 
@@ -77,28 +77,9 @@
 %.html : %.pyx
 	cython -a $<
 
-# Check for files not installed
-check-files:
-	$(PYTHON) -c 'from nisext.testers import check_files; check_files("dipy")'
-
-# Print out info for possible install methods
-check-version-info:
-	$(PYTHON) -c 'from nisext.testers import info_from_here; info_from_here("dipy")'
-
-# Run tests from installed code
-installed-tests:
-	$(PYTHON) -c 'from nisext.testers import tests_installed; tests_installed("dipy")'
-
-# Run tests from installed code
-sdist-tests:
-	$(PYTHON) -c 'from nisext.testers import sdist_tests; sdist_tests("dipy")'
-
-bdist-egg-tests:
-	$(PYTHON) -c 'from nisext.testers import bdist_egg_tests; bdist_egg_tests("dipy")'
-
 source-release: clean
 	$(PYTHON) -m compileall .
-	$(PYTHON) setup.py sdist --formats=gztar,zip
+	$(PYTHON) -m build --sdist --wheel .
 
 binary-release: clean
 	$(PYTHON) setup_egg.py bdist_egg

=== requirements.txt ===
# Check against .travis.yml file and dipy/info.py
cython>=0.29.24, !=0.29.29
numpy>=1.22.4
scipy>=1.8.1
nibabel>=4.0.0
h5py>=3.7.0
packaging>=19.0
tqdm>=4.30.0
trx-python>=0.2.9

=== doc/Makefile ===
--- 
+++ 
@@ -43,27 +43,13 @@
 	@echo "Build API docs...done."
 
 examples-clean:
-	-cd examples_built && rm -rf *.py *.rst *.png fig
-
-examples-clean-tgz: examples-clean examples-tgz
-	../tools/pack_examples.py ../dist
-
-examples-tgz: rstexamples
-	../tools/pack_examples.py ../dist
+	rm -rf examples_revamped
+	-cd examples_built && find . -not -name "README" -not -name ".gitignore" -exec rm -rfd {} \; || true
 
 gitwash-update:
 	python ../tools/gitwash_dumper.py devel dipy --repo-name=dipy --github-user=dipy \
             --project-url=https://dipy.org \
             --project-ml-url=https://mail.python.org/mailman/listinfo/neuroimaging
-
-html-legacy: api rstexamples html-after-examples-legacy
-	# build full docs including examples
-
-html-after-examples-legacy:
-	# Standard html build after examples have been prepared
-	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) _build/html
-	@echo
-	@echo "Build finished. The HTML pages are in _build/html."
 
 html: api
 	#  Standard html build after examples have been prepared
@@ -107,9 +93,7 @@
 	@echo "To view the help file:"
 	@echo "# assistant -collectionFile _build/qthelp/dipy.qhc"
 
-latex: rstexamples latex-after-examples
-
-latex-after-examples:
+latex: api
 	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) _build/latex
 	@echo
 	@echo "Build finished; the LaTeX files are in _build/latex."
@@ -132,11 +116,6 @@
 	@echo "Testing of doctests in the sources finished, look at the " \
 	      "results in _build/doctest/output.txt."
 
-rstexamples: rstexamples-stamp
-rstexamples-stamp:
-	cd examples_built && ../../tools/make_examples.py
-	touch $@
-
 pdf: pdf-stamp
 pdf-stamp: latex
 	cd _build/latex && make all-pdf

=== debian/changelog ===
dipy (1.8.0-2ubuntu2) noble; urgency=medium

  * No-change rebuild with Python 3.12 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 10 Apr 2024 17:11:37 +0000

dipy (1.8.0-2ubuntu1) noble; urgency=medium

  * Do not fail when attempting to clean up after a nocheck build

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 12 Feb 2024 20:19:56 +0000

dipy (1.8.0-2) unstable; urgency=medium

  * fix-endianness.patch: new: fix test failure on s390x.
  * fix-privacy-breaches.patch: declare forwarding not needed.
  * clear-cython.patch: new: remove cython dependency. (Closes: #1060438)
  * d/rules: skip long tests at build time.
    This is an attempt to significantly reduce build time, notably on slow
    builders like armel or riscv64, the latter having been hogged for more
    than thirteen hours.  Tests have also more verbose output to ease time
    stamping, in case other tests still affect significantly total time.
  * d/rules: merge s390x and long test skip specs.
    This rationalizes the way specifications are handled and resolves
    problems caused by stateful changes caused by raw removal of files
    in the s390x case.
  * d/t/*: move tests to script run-unit-test.
    This makes modifications to the test command easier to read, and also
    facilitates future editions.  The new test also ensures all supported
    python3 versions are indeed tested, and it includes an exclusion list
    in order to avoid running into debci time limits. (Closes: #1058661)
  * d/t/run-unit-test: also skip s390x tests.
  * d/rules,d/t/run-unit-test: warn that skips must be consistent.
  * d/rules: remove unused variable related to cython version.

 -- Étienne Mollier <emollier@debian.org>  Mon, 15 Jan 2024 20:49:26 +0100

dipy (1.8.0-1) unstable; urgency=medium

  * New upstream version 1.8.0  (Closes: #1060176)
  * Patches deleted after application upstream: python3, crossbuild.patch,
    spelling-error-in-binary.patch, and fix-invalid-version.patch.
  * Patches refreshed: deb_no_sources_for_docs patch,
    skip-tests-needing-internet.patch, skip_wall-clock_test.patch,
    no-network.patch, skip-stringent-test.patch and relay_comparison.patch.
  * d/{control,rules}: migrate to dh-sequence-python3.
  * d/control: build depends on pybuild-plugin-pyproject and python3-mesonpy.
  * d/control: doc build depends on python3-skimage and python3-sphinx-design.
  * d/control: build time tests now depend on python3-trx-python.
  * d/control: python-dipy-doc depends on libjs-sphinxdoc & node-mathjax-full.
  * d/t/control: remove needs-internet restriction.
    The test suite is in a state that works appropriately without Internet.
  * d/rules: declare matplotlib backend in environment.
  * d/rules: slight attempt at improving the general readability.
  * d/rules: fix the build date in documentation.
  * d/rules: update dist-packages cleanup pattern.
  * d/rules: replace references to cdn jsdelivr by uses of a local file.
  * d/rules: remove embedded sphinx javascript.
    This is done in favor of using links to the canonical scripts instead.
  * d/rules: introduce dh_fixperms scripting.
    This fixes a couple of occurrences of executables not elf nor scripts.
  * d/python3-dipy.install: copy all example files instead of just scripts.
  * d/python-dipy-doc.links: point to libjs-sphinxdoc scripts.
  * sphinx-default.patch: new: apply default theme.
    This avoids depending on grg theme not available yet.
  * skip-tests-needing-internet.patch: skip more tests.
  * fix-i386.patch: zero precision for test_ascm_accuracy.
    The test is not capable of decimal precision on i386, and possibly
    other 32-bit cpu architectures.
  * fix-privacy-breaches.patch: new: uninline youtube video.

 -- Étienne Mollier <emollier@debian.org>  Wed, 10 Jan 2024 22:26:24 +0100

dipy (1.7.0-4) unstable; urgency=medium

  * Team upload.
  * Take over the suggested solution by Drew Parsons to avoid comparison of
    floating point numbers
    Closes: #1053265

 -- Andreas Tille <tille@debian.org>  Tue, 07 Nov 2023 14:10:28 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: dipy
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
            Michael Hanke <mih@debian.org>,
            Étienne Mollier <emollier@debian.org>
@@ -7,12 +8,14 @@
 Testsuite: autopkgtest-pkg-python
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               dh-python,
+               dh-sequence-python3,
+               pybuild-plugin-pyproject,
                libgomp1,
                cython3,
                python-is-python3,
                python3-all-dev,
                python3-setuptools,
+               python3-mesonpy,
                python3-numpy,
                python3-scipy,
                python3-h5py <!nocheck>,
@@ -23,12 +26,15 @@
                python3-pandas <!nocheck>,
                python3-tables <!nocheck>,
                python3-tk <!nocheck>,
+               python3-trx-python <!nocheck>,
                python3-sklearn <!nocheck>,
                python3-tqdm <!nocheck>,
                xvfb <!nocheck>,
                xauth <!nocheck>
-Build-Depends-Indep: python3-sphinx,
-                     python3-numpydoc
+Build-Depends-Indep: python3-sphinx <!nodoc>,
+                     python3-numpydoc <!nodoc>,
+                     python3-skimage <!nodoc>,
+                     python3-sphinx-design <!nodoc>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/dipy
 Vcs-Git: https://salsa.debian.org/med-team/dipy.git
@@ -100,7 +106,9 @@
 Section: doc
 Depends: ${misc:Depends},
          libjs-jquery,
-         libjs-mathjax
+         libjs-mathjax,
+         libjs-sphinxdoc,
+         node-mathjax-full
 Suggests: python3-dipy
 Description: Python library for the analysis of diffusion MRI datasets -- documentation
  DIPY is a library for the analysis of diffusion magnetic resonance

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYBUILD_NAME=dipy
export MPLBACKEND=Agg
export MPLCONFIGDIR=/tmp
export HOME=/tmp

ifeq (,$(findstring get-orig-source, $(MAKECMDGOALS)))
export http_proxy=http://127.0.0.1:9/
export https_proxy=https://127.0.0.1:9/
endif

PACKAGE3_NAME = python3-$(PYBUILD_NAME)
PACKAGE3_ROOT_DIR = $(CURDIR)/debian/${PACKAGE3_NAME}
INSTALL_PATH = $(CURDIR)/debian/tmp
PY3VERS = $(shell py3versions -vr)
BUILD_DATE := $(shell \
	date \
		--utc \
		--date="@$${SOURCE_DATE_EPOCH:-$(shell date +%s)}" \
		'+%B %d, %Y' \
)
SPHINXOPTS := -D today=\"$(BUILD_DATE)\"

# WARNING: test specifications below should match d/t/run-unit-test!

# These tests hog resources because they are too long, so it is preferable to
# skip them to give the infrastructure some breath.
SKIP_LONG_TESTS := \
	not dipy/align/tests/test_streamwarp.py \
	and not dipy/denoise/tests/test_lpca.py \
	and not dipy/reconst/tests/test_sfm.py \
	and not dipy/workflows/tests/test_reconst_csa_csd.py \
	and not dipy/workflows/tests/test_reconst_rumba.py

# These tests are too stringent for running properly on s390x.
SKIP_S390X_TESTS := \
	not dipy/align/tests/test_streamlinear.py \
	and not dipy/align/tests/test_streamline.py \
	and not dipy/tracking/tests/test_distances.py \
	and not dipy/viz/tests/test_fury.py \
	and not dipy/workflows/tests/test_align.py \
	and not dipy/workflows/tests/test_segment.py \
	and not dipy/align/tests/test_whole_brain_slr.py \
	and not dipy/data/tests/test_data.py

ifneq (,$(findstring $(DEB_BUILD_ARCH),s390x))
TEST_SPEC := $(SKIP_LONG_TESTS) and $(SKIP_S390X_TESTS)
else
TEST_SPEC := $(SKIP_LONG_TESTS)
endif

%:
	dh $@ --buildsystem=pybuild

override_dh_auto_clean:
	dh_auto_clean || true
	rm -rf .pybuild __pycache__
	find dipy -name "*\.c" -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Do not test just after build, lets install and then test
endif

override_dh_auto_build:
	chmod 0644 doc/examples/*.py
	dh_auto_build
	find -name func_coef.nii.gz -print -exec chmod 0644 '{}' ';'

execute_after_dh_auto_install:
	# Prune duplicate LICENSE file
	find debian/ -name LICENSE -delete
	# Only now lets build docs
ifeq (python-dipy-doc_,$(filter python-dipy-doc,$(shell dh_listpackages))_$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	cd doc/ \
	&& PYTHONPATH=$(shell pybuild --print build_dir --interpreter python3) \
		$(MAKE) html SPHINXOPTS="$(SPHINXOPTS)"
	# objects inventory is of no use for the package
	-rm doc/_build/html/objects.inv
	# references to cloudflare and github are privacy breaches
	sed 's@https://cdnjs\.cloudflare\.com/ajax/libs/mathjax/[^/]\+/@file:///usr/share/javascript/mathjax/unpacked/@' \
		-i doc/_build/html/*.html \
		   doc/_build/html/interfaces/*.html \
		   doc/_build/html/theory/*.html
	sed 's@https://cdn\.jsdelivr\.net/npm/mathjax[@]3/es5/tex-mml-chtml\.js@file:///usr/share/nodejs/mathjax-full/es5/tex-mml-chtml.js@' \
		-i doc/_build/html/*.html \
		   doc/_build/html/interfaces/*.html \
		   doc/_build/html/reference/*.html \
		   doc/_build/html/theory/*.html
	# FIXME: references to github are for images part of dipy_data, which
	# is not available in debian; these may need packaging to solve the
	# privacy breach here.
endif
	# Run tests later on
	# cd build to prevent use of local/not-built source tree
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -ex \
	; for PYTHON in $(PY3VERS) \
	; do	PYPKG="$(PACKAGE3_ROOT_DIR)/usr/lib/python$$PYTHON/dist-packages" \
	;	export PYTHONPATH="$$PYPKG" \
	;	echo "I: Running Dipy unittests using $$PYTHON" \
	;	cd "$$PYPKG" \
	;	PATH=$(PACKAGE3_ROOT_DIR)/usr/bin:$$PATH \
		xvfb-run -a -s "-screen 0 1280x1024x24 -noreset" \
			python$$PYTHON -m pytest -v -k '$(TEST_SPEC)' dipy \
	;	rm .pytest_cache -rf \
	; done
endif
	# Cleanup files landing unnecessarily in the python3 modules directory.
	rm -fv debian/$(PACKAGE3_NAME)/usr/lib/python3*/dist-packages/*.nii.gz
	rm -fv debian/$(PACKAGE3_NAME)/usr/lib/python3*/dist-packages/*.trk
	rm -fv debian/$(PACKAGE3_NAME)/usr/lib/python3*/dist-packages/affine.txt
	# Cleanup files landing in non-standard path
	rm -rfv debian/$(PACKAGE3_NAME)/usr/doc

## "Instantiate" both rules so dh sees them
override_dh_python3:
	set -e \
	; test -d debian/$(PACKAGE3_NAME)/usr/lib || exit 0 \
	; for lib in $$(find debian/$(PACKAGE3_NAME)/usr/lib -name "*.so") \
	; do	sdir=$$(dirname $$lib) \
	;	tdir=debian/$(PACKAGE3_NAME)-lib/$${sdir#*$(PACKAGE3_NAME)/} \
	;	mkdir -p "$${tdir}" \
	;	mv -v "$${lib}" "$${tdir}" \
	; done
	dh_numpy3 -p$(PACKAGE3_NAME)-lib
	dh_python3

# immediately useable documentation and example data
override_dh_compress:
	dh_compress -X.py -X.html -X.css -X.jpg -X.txt -X.js -X.json -X.rtc \
		-X.par -X.bin -Xobjects.inv

execute_before_dh_link-indep:
	rm -fv debian/python-dipy-doc/usr/share/doc/python-dipy-doc/html/_static/doctools.js
	rm -fv debian/python-dipy-doc/usr/share/doc/python-dipy-doc/html/_static/language_data.js
	rm -fv debian/python-dipy-doc/usr/share/doc/python-dipy-doc/html/_static/searchtools.js

execute_after_dh_fixperms-arch:
	# Fix a couple of executables neither elf nor scripts.
	find debian/$(PACKAGE3_NAME)/usr/lib/python3*/dist-packages/ \
		-name '*.py' \
		-exec chmod -x '{}' '+'

execute_before_dh_clean:
	rm -rf build doc-stamp
	$(MAKE) -C doc clean

override_dh_dwz:
	dh_dwz || true

inject-doc-examples:
	mkdir -p doc-examples
	tar -C doc-examples --strip-components 1 \
		-xzvf ../tarballs/$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM).orig-doc-examples.tar.gz

=== debian/tests/control ===
--- 
+++ 
@@ -1,4 +1,4 @@
-Test-Command: cp -a /usr/lib/python3/dist-packages/dipy $AUTOPKGTEST_TMP && cp -a dipy/data $AUTOPKGTEST_TMP/dipy && cd $AUTOPKGTEST_TMP && HOME=/tmp MPLCONFIGDIR=/tmp/ xvfb-run --auto-servernum --server-num=20 -s "-screen 0 1024x768x24 -ac +extension GLX +render -noreset" python3 -m pytest dipy
+Tests: run-unit-test
 Depends: @, python3-all,
             python3-pytest,
             xvfb, xauth,
@@ -7,7 +7,7 @@
             python3-nibabel,
             python3-tables,
             python3-sklearn
-Restrictions: allow-stderr, needs-internet
+Restrictions: allow-stderr
 
 # Try running examples as autopkgtest to address bug #994575 - but
 # several of them seem to require user interaction or additional
